from django.urls import path
from . import views, views_vendor_api, views_part_api

urlpatterns = [
    # path('api/<str:role>/<str:action>/', views.api),
    path('vendor/create/', views.new_vendor),
    path('part/create/', views.new_part),
    path('part/edit/list/', views.my_draft_parts),
    path('part/ecn/create/', views.new_part_ECN),
    path('part/detail/', views.part_detail),
    path('part/upgrade/', views.part_upgrade),      # todo 更新版本号
    path('part/my_list/', views.my_part_list),
    path('ECN/my_signoff/', views.my_ECN_signoff_list),
    path('ECN/my_list/', views.my_ECN_list),
    path('ECN/detail/', views.ECN_detail),
    path('part/search/', views.part_search),
    path('part/where_used/', views.part_whereused),

]

# API urls (vendor)
urlpatterns += [
    path('vendor/code/check/', views_vendor_api.code_check),
    path('vendor/file/', views_vendor_api.file),
    path('vendor/name/search/', views_vendor_api.search_vendor),
]

# API urls (part)
urlpatterns += [
    path('part/pn/check/', views_part_api.pn_check),
    path('part/pn/draft/', views_part_api.get_draft_part),
    path('part/file/', views_part_api.file),
    path('part/EOL/', views_part_api.part_EOL),
    path('part/pn/search/', views_part_api.search_part_number),
    path('part/ecn/part_detail/', views_part_api.ecn_part_detail),
    path('part/attachment/maxsize/', views_part_api.attachment_maxsize),
]