from django.urls import path, re_path
from . import views, views_company, views_company_api, view_internal

urlpatterns = [
    # path('api/<str:role>/<str:action>/', views.api),
    path('', views.login),
    path('register/', views.register),
    path('logout/', views.logout),
    path('home/', views.home),
    path('home/user/profile/', views.user_profile),
    path('home/user/password/', views.user_password),
    path('home/company/user/create/', views_company.new_user),
    path('home/company/profile/', views_company.profile),
    path('home/company/user/manager/', views_company.user_manager),
    re_path(r'upload/*', views.get_upload_file)
]

# API urls
urlpatterns += [
    path('home/company/api/user/list/', views_company_api.user_list),
    path('home/company/api/user/delete/', views_company_api.user_delete),
    path('home/company/api/user/admin/change/', views_company_api.user_admin_change),
    path('home/company/api/user/search/', views_company_api.user_search)
]

# internal management urls

urlpatterns += [
    path('internal/', view_internal.login)
]