from django.http import HttpResponseRedirect
from django.shortcuts import render
from .models import User, Company
from .model_handler import InternalUserHandler
from django.contrib.auth.hashers import make_password, check_password


def login(request):
    if request.method == 'GET':
        return render(request, template_name='info/internal/login.html')

    if request.method == 'POST':
        internal_user = InternalUserHandler.login(email=request.POST.get('name').strip(), password=request.POST.get('password').strip())
        if internal_user:
            request.session['internal_user_id'] = internal_user.id
            # todo 检索用户权限
            if internal_user.psw_change_required:    # 默认密码，导入修改密码页面
                return HttpResponseRedirect('/internal/home/user/password/')
            else:
                return HttpResponseRedirect('/internal/home/')
        else:
            return render(request=request, template_name='info/directPage.html', context={'alertMsg': '登录失败', 'dirLink': '/internal/'}) 